<?php


/**
 * Class for network settings
 */
class Net_conf {


    function save($ba,$bc){
        $ba->set('hostname',sqlite_escape_string ($_POST['hostname']));
	$bc->set("root", "lan-dhcp", sqlite_escape_string($_POST['dhcp']));
	$bc->set("root", "lan-ipaddr", sqlite_escape_string ($_POST['ipaddr']));
	$bc->set("root", "lan-netmask", sqlite_escape_string ($_POST['netmask']));
	$bc->set("root", "lan-gateway", sqlite_escape_string ($_POST['gateway']));
	$bc->set("root", "lan-mtu", sqlite_escape_string (intval($_POST['lan_mtu'])));
        $nameserver=$_POST['lan_nameserver'];
        if ($_POST['lan_nameserver2']!="") $nameserver.=";".$_POST['lan_nameserver2'];
	$bc->set("root", "lan-nameserver", sqlite_escape_string ($nameserver));
	$bc->set('root', 'disable_ncs', (isset($_POST['disable_ncs']) ? '1' : '0'));
	$bc->set('root', 'beroAvahi-enabled', (isset($_POST['beroAvahi-enabled']) ? '1' : '0'));

	if (isset($_POST['vlanenable'])){
		$bc->set("root","vlan-enable",$_POST['vlanenable']);
		$bc->set("root","vlan-id",$_POST['vlanid']);
		$bc->set("root","vlan-prio",$_POST['vlan-prio']);
	} else {
		$bc->set("root","vlan-enable","0");
		$bc->set("root","vlan-id","");
		$bc->set("root","vlan-prio","");
	}

	$routing="";
	for ($i=0; $i<count($_POST['route_net']);$i++){
		if ($_POST['route_net'][$i]!="" && $_POST['route_netmask'][$i]!="" && $_POST['route_gateway'][$i]!=""){
			($routing=="") ? $routing.=$_POST['route_net'][$i]."/".$_POST['route_netmask'][$i]."/".$_POST['route_gateway'][$i] : $routing.=",".$_POST['route_net'][$i]."/".$_POST['route_netmask'][$i]."/".$_POST['route_gateway'][$i];
		}
	}
	$bc->set("root","routing",$routing);



        $ret.=Helper::activate(3,true,'net_conf',ACTIVATE);
	$ret.="<br><div class='center'><b><font color=red>".NETWORK_CONFIGURATION_APPLIED_DIS."</font></b></div>";
        return $ret;
    }

	function display($args) {
		include('./includes/header.php');
		require_once("./includes/lang.php");
		include '/usr/fallback/beroConf.php';
		$image_dir = "/mnt/images";
		$files = 0;
		$bc = new beroConf('root');
		$ba= new beroAri();

		// args
		$m = $_GET['m'];
		$q = $_GET['q'];
		$start = $_GET['start'];
		if (!$bc->valid()) {
			$ret.= '<h3>Error:</h3><b>Failed to connect to config database!</b><br>';
			exit(0);
		}


		//Äderungen speichern
		switch ($_POST['action']) {
			case 'apply':

                                if ($_POST['dhcp']=="yes"){
                                    $ret.=$this->save($ba, $bc);
                                }else{
                                    if ($_POST['ipaddr']!=$_POST['gateway']){
                                            $result=exec("/usr/sbin/netconfigverify ".$_POST['ipaddr']." ".$_POST['netmask']." ".$_POST['gateway']." 2>&1");
                                            if (substr_count($result,"Failed")>0){
                                                    $ret.="<br><div class='center'><b><font color=red>".NETWORK_FAILED_ERROR_DIS."</font></b></div>";
                                            }else{
                                                $ret.=$this->save($ba,$bc);
                                            }
                                    }else{
                                            $ret.= "<br><div class='center'><font color=red><b>".NETWORK_FAILED_ERROR_DIS."</b></font></div>";
                                    }
                                }
				break;
		}

		$iface = $bc->get('root', 'lan-iface');
		$dns = explode(';', $bc->get('root', 'lan-nameserver'));
		$dhcp = in_array($bc->get('root', 'lan-dhcp'), array('yes', '1'));
                //Show default values for DNS and secondary DNS
                if ($dhcp){
                    $dns[0]='8.8.8.8';
                    $dns[1]='8.8.4.4';
                }
                
		$ret.="<script>
		function show_vlan(ch){
			if (!ch){
				document.getElementById('vlan_id').style.display='none';
				document.getElementById('vlan_prio').style.display='none';
			}else{
				document.getElementById('vlan_id').style.display='';
				document.getElementById('vlan_prio').style.display='';
			}
		}
		</script>";
		$ret.='<br/><form class="extensions_form" name="networkform" id="networkform" method="POST" action="" onsubmit="return (checkvlan(vlanenable.checked));">
			<input type="hidden" name="action" value="apply">
			<table id="table" class="contenttoc" width="35%">
				<tr>
				<th colspan="2">'.NETWORK_TABLE_HEADER_DIS.'</th>
				</tr>
				<tr>
					<td colspan="2" align="center">
						<input type="radio" name="dhcp" onmouseover=\'Tip("' . NET_CONF_DHCP . '")\' onmouseout="UnTip()" value="yes"' . ( $dhcp ? ' checked' : '' ) . '/>DHCP
						<input type="radio" name="dhcp" id="static"  onmouseover=\'Tip("' . NET_CONF_STATIC . '")\' onmouseout="UnTip()" value="no"' . ( $dhcp ? '' : ' checked' ) . '/>'.NETWORK_STATIC_DIS.'
					</td>
				</tr>
				<tr>
					<td style="text-align:center"><b>'.NETWORK_IP_ADDRESS_DIS.': </b></td>
					<td>
						<input name="ipaddr" type="text" size="15" id="ipaddr" onmouseover=\'Tip("' . NET_CONF_IP_ADDRESS . '")\' onmouseout="UnTip()" value="' . $bc->get("root", "lan-ipaddr") . '">
					</td>
				</tr>
				<tr>
					<td style="text-align:center"><b>'.NETWORK_NETMASK_DIS.': </b></td>
					<td>
						<input name="netmask" type="text" size="15" id="netmask"
							onclick="if (netmask.value==\'\') netmask.value=makeNetMask(ipaddr.value);"
							onmouseover=\'Tip("' . NET_CONF_NETMASK . '")\' onmouseout="UnTip()" value="' . $bc->get("root", "lan-netmask") . '">
					</td>
				</tr>
				<tr>
					<td style="text-align:center"><b>'.NETWORK_GATEWAY_DIS.': </b></td>
					<td>
						<input name="gateway" type="text" size="15" id="gateway" onmouseover=\'Tip("' . NET_CONF_GATEWAY . '")\' onmouseout="UnTip()" value="' . $bc->get("root", "lan-gateway") . '">
					</td>
				</tr>
                                <tr>
					<td style="text-align:center"><b>'.NETWORK_PRIMARY_NAME_SERVER_DIS.': </b></td>
					<td>
						<input name="lan_nameserver" type="text" size="15" id="lan_nameserver" onmouseover=\'Tip("'.NET_CONF_NAMESERVER.'")\' onmouseout="UnTip()" value="' . $dns[0] . '">
					</td>
				</tr>
				<tr>
					<td style="text-align:center"><b>'.NETWORK_SECONDARY_NAME_SERVER_DIS.': </b></td>
					<td>
						<input name="lan_nameserver2" type="text" size="15" id="lan_nameserver2" onmouseover=\'Tip("'.NET_CONF_SECONDARY_NAMESERVER.'")\' onmouseout="UnTip()" value="' . $dns[1] . '">
					</td>
				</tr>
                                <tr>
					<td style="text-align:center"><b>'.NETWORK_HOSTNAME_DIS.': </b></td>
					<td>
						<input name="hostname" type="text" size="15" checkDigChar="true" id="hostname" value="' . $ba->get("hostname") . '">
					</td>
				</tr>
				<tr>
					<th colspan="2">
						'. NETWORK_ADVANCED_DIS .'
					</th>
				</tr>
				<tr>
					<td style="text-align:center"><b>'.NETWORK_MTU_SIZE_DIS.': </b></td>
					<td>
						<input name="lan_mtu" type="text" size="15" id="lan_mtu" onmouseover=\'Tip("'.NET_CONF_MTU_SIZE.'")\' onmouseout="UnTip()" value="' . $bc->get("root", "lan-mtu") . '">
					</td>
				</tr>
				<tr>
					<td><b>'.NETWORK_AVAHI_DIS.':</b></td>
					<td>';
					if ($bc->get('root','beroAvahi-enabled')=="1") $ret.='<input type="checkbox" name="beroAvahi-enabled" value="1" checked>';
					else $ret.='<input type="checkbox" name="beroAvahi-enabled" value="1">';
					$ret.='</td>
				</tr>
				<tr>
					<td><b>' . NETWORK_CONFIG_SERVER_DIS . ':</b></td>
					<td>
					<input type="checkbox" name="disable_ncs" value="1" ' . (($bc->get('root', 'disable_ncs') == '1') ? 'checked ' : '' ) . '/>
					</td>
				</tr>
				<tr>
					<td style="text-align:center"><b>'.NETWORK_VLAN_ENABLE_DIS.': </b></td>
					<td>';
					if ($bc->get("root", "vlan-enable")==1)
						$ret.='<input name="vlanenable" type="checkbox" id="vlanenable" onclick="show_vlan(document.getElementById(\'vlanenable\').checked);" value="1" checked>';
					else
						$ret.='<input name="vlanenable" type="checkbox" id="vlanenable" onclick="show_vlan(document.getElementById(\'vlanenable\').checked);" value="1">';
					$ret.='</td>
				</tr>
				<tr id="vlan_id">
					<td style="text-align:center"><b>'.NETWORK_VLAN_ID_DIS.': </b></td>
					<td>
						<input name="vlanid" type="text" size="15" id="vlanid" value="' . $bc->get("root", "vlan-id") . '">
					</td>
				</tr>
				<tr id="vlan_prio">
					<td style="text-align:center"><b>'.NETWORK_VLAN_PRIORITY_DIS.': </b></td>
					<td>
						'.$this->vlan_prio().'
					</td>
				</tr>
				'.$this->routing().'
				<tr id="add_route">
					<td style="text-align:center" colspan="2">
						<input type="button" id="add_route_button" value="'.BUTTON_ADD_ROUTE_ENTRY.'">
					</td>
				</tr>
				<tr>
					<td colspan="2" align="center">
						<input type="submit" name="Apply" value="'.BUTTON_SAVE.'" onmouseover=\'Tip("' . NET_CONF_APPLY . '")\' onmouseout="UnTip()">
					</td>
				</tr>
			</table>
			</form>
			<script>
                            $( "#networkform" ).validate({
                                rules: {
                                    lan_mtu: {
                                        digits: true,
                                        range: [150, 1500]
                                    },
                                    vlanid: {
                                        digits: true,
                                        required: true,
                                        range: [1, 4094]
                                    },
                                    ipaddr: {
                                        verifyIP: "#static:checked",
                                        required: "#static:checked"
                                    },
                                    lan_nameserver: {
                                        verifyIP: "#static:checked",
                                        required: {
                                            depends: function (element) {
                                                return $("#lan_nameserver2").is(":filled");
                                            }
                                        }
                                    },
                                    lan_nameserver2: {
                                        verifyIP: "#static:checked",
                                    },
                                    gateway: {
                                        verifyIP: "#static:checked",
                                        required: "#static:checked"
                                    },
                                    netmask: {
                                        verifyIP: "#static:checked",
                                        required: "#static:checked"
                                    },

                                }
                            });
                            show_vlan(document.getElementById("vlanenable").checked);
				$("#add_route_button").click(function() {
					$("#add_route").before("<tr>"+
						"<td><b>Route target</b></td>"+
						"<td><input name=\'route_net[]\' verifyIP=\'true\' class=\'net\'>/<input name=\'route_netmask[]\' size=\'2\' class=\'netmask\' digits=\'true\' required=\'true\' min=\'0\' max=\'32\' maxlength=\'2\'></td>"+
						"</tr>"+
						"<tr>"+
						"<td><b>Route gateway</b></td>"+
						"<td><input name=\'route_gateway[]\' verifyIP=\'true\' class=\'gateway\' size=\'24\'></td>"+
                                            "</tr>");
				});
			</script>';

		return $ret;
	}

	function vlan_prio(){
		$bc = new beroConf('root');
		$bits = array("000","001","010","011","100","101","110","111");
		$cbox='<select name="vlan-prio">';
		$i=0;
		foreach ($bits as $key=>$value){
			if ($bc->get("root","vlan-prio")==$value)
				$cbox.="<option value='".$value."' selected>".$i++."</option>";
			else
				$cbox.="<option value='".$value."'>".$i++."</option>";
		}
		$cbox.='</select>';
		return $cbox;

	}

	function routing(){
		$bc = new beroConf('root');
		$result="";
		if ($bc->get("root","routing")!=""){
			$routes=explode(",",$bc->get("root","routing"));
			foreach($routes as $value){
				list($route_net, $route_netmask, $route_gateway) = explode("/", $value);
				$result.="<tr>
							<td>Route target</td>
							<td><input name='route_net[]' verifyIP='true' class='net' value='$route_net'>/<input name='route_netmask[]' digits='true' required='true' min='0' max='32' size='2' maxlength='2' class='netmask' value='$route_netmask'></td>
						</tr>
						<tr>
							<td>Route gateway</td>
							<td><input name='route_gateway[]' verifyIP='true' class='gateway' value='$route_gateway' size='24'></td>
						</tr>";
			}
		}
		return $result;
	}


}


?>
